stages:
  - .pre
  - fmt 
  - validate
  - plan
image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'
fmt:
  stage: fmt
  script:
    - terraform fmt
validate:
  stage: validate
  before_script:
    - rm -rf .terraform
    - terraform --version
    - terraform init
  script:
    - terraform validate
plan:
  stage: plan
  before_script:
    - rm -rf .terraform
    - terraform --version
    - terraform init
  script:
    - terraform plan -out "planfile"
  dependencies:
    - validate
  artifacts:
    paths:
      - planfile

# terraform-job:
# # stage: test
# include:
#   - local: '/gitlab-ci-templates/.terraform-gitlab-ci.yaml'
# script:
#   - echo "your usual tests go here" 

# include:
#   - remote: 'https://gitlab.com/yesolutions/gitlab-ci-templates/raw/main/templates/pre-commit-autofix.yaml'

# variables:
#   # since we're not using merge request pipelines in this example,
#   # we will configure the pre-commit job to run on branch pipelines only.
#   # If you ARE using merge request pipelines, you can omit this section
#     PRE_COMMIT_DEDUPLICATE_MR_AND_BRANCH: "false"
#     PRE_COMMIT_AUTO_FIX_BRANCH_ONLY: "true"



